> For the complete documentation index, see [llms.txt](https://docs.knn3.xyz/graphql/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.knn3.xyz/graphql/categories/possession.md).

# Possession

Possession API is used for querying Token ownership and NFT ownership and ENS ownership, Developers can learn the asset information owned by users through the query address.

### **Token**

It supports querying how many and which Tokens an address owns, and on the contrary, can also query an Token that has been held by which addresses.&#x20;

* Query the token owned by the address

```graphql
{
  addrs(where:{address:"0x…"}){
    address
    holdTokens{
      name
      symbol
    }
  }
}
```

* Which addresses are held by the Token

```graphql
{
  tokens{
    name
    addrsHold{
      address
    }
  }
}
```

### **NFT**&#x20;

It supports querying how many and which NFTs an address owns, and on the contrary, can also query an NFT has been held by which addresses.&#x20;

* Address held by NFT

```graphql
{
  addrs{
  	address
  	holdNfts{
    	name
    	symbol
 	  }
  }
}
```

* Which addresses are held by NFT

```graphql
{
  nfts{
    name
    symbol
    addrsHold{
      address
    }
  }
}
```

### **ENS**

You can query the number and specific information of the ENS owned by an address. On the contrary, you can also query the address where an ENS is held.

* Address owned by ENS

```graphql
{
  addrs{
    address
    ens
  }
}
```

* Query address according to ENS

```graphql
{
  ens(where:{ens:"xxxx.eth"}){
    address
  }
}
```

### Polygon

Access the information and number of NFT and token held by address

```graphql
{
  addrs(where:{address:"0x88520C10ad3d35aD2D3220CdE446CcB33f09331B"}){
    holdPolygonNfts{
      name
      symbol
      nftCount
      contract
    }
    holdPolygonTokens{
      name
      symbol
      tokenCount
      contract
    }
  }
}
```

Access the holder's address according to NFT

```graphql
{
    polygon_nfts{
    contract
    name 
    symbol
    addrsHold{
      address
    }
  }
}
```

Access the holder's address according to token

```graphql
{
    polygon_tokens{
    contract
    name 
    symbol
    addrsHold{
      address
    }
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.knn3.xyz/graphql/categories/possession.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
